Bug 112449 - (TG3) driver doesn't work properly with bcm5700 nic
(TG3) driver doesn't work properly with bcm5700 nic
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel (Show other bugs)
3.0
i386 Linux
medium Severity high
: ---
: ---
Assigned To: David Miller
Brian Brock
tg3
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2003-12-19 15:43 EST by mike
Modified: 2007-11-30 17:06 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-05-11 21:08:04 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
bcm5700 driver (111.85 KB, patch)
2003-12-19 15:44 EST, mike
no flags Details | Diff

  None (edit)
Description mike 2003-12-19 15:43:28 EST
Description of problem:
tigon3 driver redhat includes in kernel to work with broadcom cards: 
if setting speed/duplex manually, interface stops responding shortly 
after being up (might also not work properly in autoneg mode but I 
haven't tried).

kernel: linux-2.4.21-4.0.1.EL
(This is just the version i've done my testing on specific to using 
the redhat kernel package, i have the same problem in custom builds 
of kernels of different versions when using tg3 in place of bcm5700).
server: dell poweredge 2650 with:
Broadcom Corporation NetXtreme BCM5700 Gigabit Ethernet
(at 14e41644)


How reproducible:
always


Steps to Reproduce:
1. have the above server with the above card
2. use the tg3 driver for that interface
3. try for eg: ethtool -s eth4 speed 100 duplex full autoneg off
4. ethtool eth4 # -> doesn't show the applied settings, (mii-tool 
doesn't work either)
5. transfer a lot of packets on that interface... it stops 
responding. see rx/tx errs using netstat -ni
6. it comes back to life if you bring the interface down/up

Solution:
I'll include a patch to add the bcm driver to this redhat kernel 
(patch could be applied to other versions as well though).
It just adds the bcm drivers and allows CONFIG_NET_BROADCOM to 
actually do something (in the redhat kernel it appears it was just 
taken out and selecting that option doesn't do anything).
I've tested it on more than one system, with different kernel 
versions etc. and it works perfectly.

Additional info:
After applying the patch, change tg3 in modules.conf to bcm5700 if 
using modules.
Comment 1 mike 2003-12-19 15:44:57 EST
Created attachment 96643 [details]
bcm5700 driver
Comment 2 Jeff Garzik 2004-01-12 13:40:53 EST
Can you provide 'lspci' and 'dmesg' output, so that we may identify
your hardware, and work on the problem?

The bcm5700 has its own bugs, and will not be used.
Comment 3 mike 2004-01-12 14:18:46 EST
03:08.0 Ethernet controller: Broadcom Corporation NetXtreme BCM5700 
Gigabit Ethernet (rev 12)

also have had speed/duplex related issues using tg3 driver for BCM5703

after searching a bit more on this it appears the issue is fairly 
well known/reported and patches exist from 
http://www.broadcom.com/drivers/downloaddrivers.php and dell...
so, sorry for reproducing that here.

drivers available from dell:
Release Title: Network: Broadcom BCM5700, NetXtreme Family of 
Adapters , Driver, Enterprise Linux, Multi Language, Multi System, 
v.2.2, A01  
Release Date: 12/30/2003 
Description: This package provides an updated tg3 driver for Broadcom 
Gigabit network cards for Red Hat Enterprise Linux 3.  

Additional Information
This RPM fixes an issue with the tg3 driver in the Red Hat 2.4.21-
4.EL series of kernels where the duplex setting cannot be manually 
configured with ethtool. 

http://support.ap.dell.com/ap/en/filelib/download/index.asp?
fileid=R71125&devid=2957&sid=PWE_FOS_XEO_2650&lang=EN&lib=0&os=LE30&se
archtype=filter
Comment 4 mike 2004-01-12 15:40:03 EST
"http://support.dell.com/FileLib/Format.aspx?
c=us&l=en&s=gen&Category=5&OS=LE30&OSL=EN&SvcTag=&SysID=PWE_FOS_XEO_26
50&DeviceID=2957&Type=&ReleaseID=R71125"
Comment 5 mike 2004-01-12 15:41:20 EST
ok well if the url doesn't work just search for network drivers for 
the 2650 for rhel3 on support.dell.com
Comment 6 Shawn Stephens 2004-01-19 08:52:38 EST
In response to comment #2, what bugs specifically does the bcm5700
driver have?  I think that the bugs in the tg3 driver not being able
to autonegotiate properly and failing far outweigh whatever bugs are
present in the bcm5700 driver. (At least it seems to work better for
folks with BMC57xx NICs)
Comment 8 David Miller 2004-03-29 18:14:05 EST
I think the current U2 candidate update should fix this
bug, can you try it out?
Comment 9 Ernie Petrides 2004-04-12 17:41:27 EDT
The latest respin of the RHEL3 U2 kernel (version 2.4.21-13.EL)
should resolve this problem.  Changing state of this bug report
to "modified" for final confirmation by reporter.  -ernie
Comment 10 John Flanagan 2004-05-11 21:08:04 EDT
An errata has been issued which should help the problem described in this bug report. 
This report is therefore being closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files, please follow the link below. You may reopen 
this bug report if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2004-188.html

Note You need to log in before you can comment on or make changes to this bug.